<?php
/**
 * @param string $string
 * @return array
 */
function getTop5WordFrequency(string $string): array
{
    $wordSplitCharactersPattern = '/[\s\p{P}]+/u';
    $words = preg_split($wordSplitCharactersPattern, $string);

    $wordFrequency = [];
    foreach ($words as $word) {
        if ($word == '') {
            continue;
        }

        if (isset($wordFrequency[$word])) {
            ++$wordFrequency[$word];
            continue;
        }

        $wordFrequency[$word] = 1;
    }

    arsort($wordFrequency);

    return array_slice($wordFrequency, 0, 5);
}


$string = 'Поблагодарив Анну Павловну за ее charmante soirée 1, гости стали расходиться.
Пьер был неуклюж. Толстый, выше обыкновенного роста, широкий, с огромными красными руками, он, как говорится, не умел войти в салон и еще менее умел из него выйти, то есть перед выходом сказать что-нибудь особенно приятное. Кроме того, он был рассеян. Вставая, он вместо своей шляпы захватил треугольную шляпу с генеральским плюмажем и держал ее, дергая султан, до тех пор, пока генерал не попросил возвратить ее. Но вся его рассеянность и неуменье войти в салон и говорить в нем выкупались выражением добродушия, простоты и скромности. Анна Павловна повернулась к нему и, с христианскою кротостью выражая прощение за его выходку, кивнула ему и сказала:
— Надеюсь увидеть вас еще, но надеюсь тоже, что вы перемените свои мнения, мой милый мсье Пьер, — сказала она.
Когда она сказала ему это, он ничего не ответил, только наклонился и показал всем еще раз свою улыбку, которая ничего не говорила, разве только вот что: «Мнения мнениями, а вы видите, какой я добрый и славный малый». И все и Анна Павловна невольно почувствовали это.
Князь Андрей вышел в переднюю и, подставив плечи лакею, накидывавшему ему плащ, равнодушно прислушивался к болтовне своей жены с князем Ипполитом, вышедшим тоже в переднюю. Князь Ипполит стоял возле хорошенькой беременной княгини и упорно смотрел прямо на нее в лорнет.
— Идите, Annette, вы простудитесь, — говорила маленькая княгиня, прощаясь с Анной Павловной. — Cest arrêté 2, — прибавила она тихо.
Анна Павловна уже успела переговорить с Лизой о сватовстве, которое она затевала между Анатолем и золовкой маленькой княгини.
— Я надеюсь на вас, милый друг, — сказала Анна Павловна тоже тихо, — вы напишете к ней и скажете мне, comment le père envisagera la chose. Au revoir 3, — и она ушла из передней.
Князь Ипполит подошел к маленькой княгине и, близко наклоняя к ней свое лицо, стал полушепотом что-то говорить ей.
Два лакея, один княгинин, другой его, дожидаясь, когда они кончат говорить, стояли с шалью и рединготом и слушали их, непонятный им, французский говор с такими лицами, как будто они понимали, что говорится, но не хотели показывать этого. Княгиня, как всегда, говорила улыбаясь и слушала смеясь.
— Я очень рад, что не поехал к посланнику, — говорил князь Ипполит, — скука... Прекрасный вечер. Не правда ли, прекрасный?
— Говорят, что бал будет очень хорош, — отвечала княгиня, вздергивая с усиками губку. — Все красивые женщины общества будут там.';

getTop5WordFrequency($string);